%define anolis_release 2

%bcond_with perl_Data_OptList_enables_optional_test
%bcond_with perl_Data_OptList_enables_extra_test

Name:           perl-Data-OptList
Summary:        Parse and validate simple name or value option pairs
Version:        0.113
Release:        %{anolis_release}%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Data-OptList
Source0:        https://cpan.metacpan.org/modules/by-module/Data/Data-OptList-%{version}.tar.gz
BuildArch:      noarch
BuildRequires:  make
BuildRequires:  perl(Sub::Install) >= 0.921 perl(warnings) perl(File::Spec) perl(Test::More) >= 0.88
BuildRequires:  perl(List::Util) perl(Params::Util) perl(strict)
BuildRequires:  perl-generators perl-interpreter perl(ExtUtils::MakeMaker) >= 6.78
BuildRequires:  coreutils findutils

%if %{with perl_Data_OptList_enables_extra_test}
BuildRequires:  perl(Test::Pod) >= 1.41 perl(Encode) 
%endif

%if %{with perl_Data_OptList_enables_optional_test}
BuildRequires:  perl(CPAN::Meta) >= 2.120900 perl(CPAN::Meta::Prereqs)
%endif

%description
perl-Data-OptList is a Perl module that provides a lightweight and
flexible option list parser. It allows users to define a set of options and
parse them from the arguments passed to the program. It also provides some
features such as applying default values to missing options, merging multiple
option lists, etc. It is commonly used for handling command-line options or
function parameters.

Hashes are great for storing named data.
If you want more than one entry for a name, you should use a list of pairs.
Even then, this is really boring to write:

$values = [
    foo => undef,
    bar => undef,
    baz => undef,
    xyz => { ... },
];

With Data::OptList, you can do this instead:

$values = Data::OptList::mkopt([
    qw(foo bar baz),
    xyz => { ... },
]);

This works is a name and any reference following a name is its value
by assuming that any defined scalar. 

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The document package provices documentation files for %{name}.

%prep
%setup -n Data-OptList-%{version} -q

for F in t/*; do
    perl -MExtUtils::MakeMaker \
	-e "ExtUtils::MM_Unix->fixin(q{$F})"
done

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} %{buildroot}

%check
make test
%if %{with perl_Data_OptList_enables_extra_test}
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"
%endif

%files
%license LICENSE
%{_mandir}/man3/Data::OptList.3*
%{perl_vendorlib}/Data/
%doc t/

%files doc
%doc Changes README

%changelog
* Thu Apr 13 2023 Heng Qi <hengqi@linux.alibaba.com> - 0.113-2
- Refactor the spec file

* Tue Feb 07 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.113-1
- remove versioned MODULE_COMPAT_ requires
- update to version 0.113

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.112-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.112-1
- init from upstream
